import { world, system, ItemStack, EntityInventoryComponent } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

const overworld = world.getDimension("overworld");

system.runInterval(() => {
    //Tue les joueurs qui sont sur un bloc de béton noir
    overworld.runCommand("execute as @a at @s if block ~~-1~ black_concrete run /kill");
    //Change le spawnpoint des joueurs qui passent sur un bloc d'or
    overworld.runCommand("execute as @a at @s if block ~~-1~ gold_block run /spawnpoint @s ~~~");
    //Detecter victoire
    overworld.runCommand("execute as @a at @s if block ~~-1~ sand run /title @s title Victory !");
    overworld.runCommand("execute as @a at @s if block ~~-1~ sand run /tp -60 -59 6");
    overworld.runCommand("execute as @a at @s if block ~~-1~ sand run /spawnpoint @s -60 -59 6");


    overworld.runCommand(`replaceitem entity @a slot.hotbar 4 paper 1 0 {"item_lock": {"mode": "lock_in_slot"}}`);
    overworld.runCommand(`replaceitem entity @a slot.hotbar 0 feather 1 0 {"item_lock": {"mode": "lock_in_slot"}}`);
});

//-----
world.beforeEvents.itemUse.subscribe((eventData) => {
    const typeIdItem = eventData.itemStack.typeId;
    const player = eventData.source;
    switch (typeIdItem) {
        case "minecraft:paper":
            eventData.cancel = true;
            system.run(async () => {
                const result = await chooseParkourUI.show(player);
                if (result.canceled) {
                    return;
                } else if (result.selection === 0) {
                    player.runCommand(`tp @s 0 -59 3`);
                    player.runCommand("/spawnpoint @s 0 -59 3");
                } else if (result.selection === 1) {
                    player.runCommand(`tp @s 0 -59 9`);
                    player.runCommand("/spawnpoint @s 0 -59 9");
                } else if (result.selection === 2) {
                    player.runCommand(`tp @s 0 -59 16`);
                    player.runCommand("/spawnpoint @s 0 -59 16");
                } else if (result.selection === 3) {
                    player.runCommand(`tp @s -60 -59 6`);
                    player.runCommand("/spawnpoint @s -60 -59 6");
                };
            });
            break;
        case "minecraft:feather":
            eventData.cancel = true;
            const {x, y, z} = player.getSpawnPoint();
            system.run(() => {
                player.teleport({x, y, z});
            });
            break;
        default:
            return;
    }
});

const chooseParkourUI = new ActionFormData();
chooseParkourUI.title = "Choose Parkour";
chooseParkourUI.button("§aEasy", "textures/blocks/wool_colored_lime");
chooseParkourUI.button("§6Medium", "textures/blocks/wool_colored_orange");
chooseParkourUI.button("§cHard", "textures/blocks/wool_colored_red");
chooseParkourUI.button("§0Lobby", "textures/blocks/wool_colored_black");